--[[
	Sorry, Encoding of this file is Shift-JIS.
	CSV

	"ނłLuaCu for AIMS"
	(C) 2013 ނłi[[j All Rights Reserved.
	arcCZXɉāApBEnjoy.

	̃R[hAӏRs[A܂ςs܂B
		Ehttp://lua-users.org/wiki/CsvUtils
		Ehttp://symfoware.blog68.fc2.com/blog-entry-455.html
	
	t@C쐬    F2012-09-16 ނł
	t@CҏWŏIF2013-11-19 ނł
		ECSVt@C2sڂ͌^AƂ[폜B
		E̕ύX csv_FromFilecsv_fromFile
		E̕ύX csv_Splitcsv_split
		E̕ύX csv_EscapeCSVcsv_escapeCSV
		E̕ύX csv_FromLinecsv_fromLine
		E̕ύX csv_FromDatalinecsv_fromDataline
		E̕ύX csv_ToCsvLinecsv_toCsvLine
		E̕ύX csv_CreateTablecsv_createTable
		E̕ύX csv_FromTextcsv_fromText
		Ecsv_SelectRecord csv_selectB
		Ecsv_fromFile ̈ύX
]]
--[[
	-- gp

	-- .lua ̒Ƀf[^ꍇ

	local t = csv_fromText(
		"NO,ID,NAME,EOL\n" ..
		"-1,ԍ,O,\n" ..
		"0,1001,\"\",\n" ..
		"EOF,,,"
	)

	-- .csvt@CꍇB

	-- data/sample1.csv
	--
	-- NO,ID,NAME,EOL
	-- -1,ԍ,O,
	-- 0,1001,"",
	-- EOF

	local t = csv_fromFile("data/sample1.csv", true)


	-- ǂݎP

	local record = csv_select( t, "ID", 1001 )
	local name = record["NAME"]


	-- ǂݎQ

	debugOut("e[uEeLXg̍ŏI=[".. #t .. "]s") --fobOo͂̂Ƃ܂B
	for row = 1, #t do
		debugOut("eLXg(".. row .. ")s")
		for key,value in ipairs(t[row]) do
			debugOut("@@".. key .. "=" .. value .. "")
		end
	end


	-- ʁF

	e[uEeLXg̍ŏI=[5]s
	eLXg(1)s
	@@NO=NO
	@@ID=ID
	@@NAME=NAME
	@@EOL=EOL
	eLXg(2)s
	@@NO=-1
	@@ID=ԍ
	@@NAME=O
	@@EOL=
	eLXg(3)s
	@@NO=0
	@@ID=1001
	@@NAME=
	@@EOL=
	eLXg(4)s
	@@NO=EOF
	@@ID=
	@@NAME=
	@@EOL=
]]


-- split֐
--
--http://symfoware.blog68.fc2.com/blog-entry-455.html
--TvR[h܂B
--LuapsplitWɖƂ̂Ƃ http://lua-users.org/wiki/SplitJoin 
--QlɎ삵֐YȂ悤ɏƂ̂ƂłB
--uÕRgɂėpEĔzz̎|`܂āA܂B
--
--Fu.vŃXvbgꍇ́u[.]vƏBiK\gĂ̂Łj
function csv_split(str, delim)
    -- Eliminate bad cases...
    if string.find(str, delim) == nil then
        return { str }
    end

    local result = {}
    local pat = "(.-)" .. delim .. "()"
    local lastPos
    for part, pos in string.gfind(str, pat) do
        table.insert(result, part)
        lastPos = pos
    end
    table.insert(result, string.sub(str, lastPos))
    return result
end



--http://lua-users.org/wiki/CsvUtils
--"share code/ideas/links, and collaborate with other users."Ƃ̂Ƃ
--܂B
-- Escape CSV quotes
-- Used to escape "'s by csv_toCSV
function csv_escapeCSV (s)
  if string.find(s, '[,"]') then
    s = '"' .. string.gsub(s, '"', '""') .. '"'
  end
  return s
end


-- Convert from CSV string to table

--http://lua-users.org/wiki/CsvUtils
--"share code/ideas/links, and collaborate with other users."Ƃ̂Ƃ
--܂B
-- scPsɂȂĂCSVƂB
-- Convert from CSV string to table (converts a single line of a CSV file)
function csv_fromLine (s)
  s = s .. ','        -- ending comma
  local t = {}        -- table to collect fields
  local fieldstart = 1
  repeat
    -- next field is quoted? (start with `"'?)
    if string.find(s, '^"', fieldstart) then
      local a, c
      local i  = fieldstart
      repeat
        -- find closing quote
        a, i, c = string.find(s, '"("?)', i+1)
      until c ~= '"'    -- quote not followed by quote?
      if not i then error('unmatched "') end
      local f = string.sub(s, fieldstart+1, i-1)
      table.insert(t, (string.gsub(f, '""', '"')))
      fieldstart = string.find(s, ',', i) + 1
    else                -- unquoted; find next comma
      local nexti = string.find(s, ',', fieldstart)
      table.insert(t, string.sub(s, fieldstart, nexti-1))
      fieldstart = nexti + 1
    end
  until fieldstart > string.len(s)
  return t
end


--http://lua-users.org/wiki/CsvUtils
--ɉρB
--Azz̓YɁAtB[h܂B
--"share code/ideas/links, and collaborate with other users."Ƃ̂Ƃ
--܂B
-- fieldnamesctB[h̔z
-- scPsɂȂĂCSVƂB
-- Convert from CSV string to table (converts a single line of a CSV file)
function csv_fromDataline (fieldnames, s)
  s = s .. ','        -- ending comma
  local t = {}        -- table to collect fields
  local fieldstart = 1
  local fieldname
  local column = 1
  repeat
    -- next field is quoted? (start with `"'?)
    if string.find(s, '^"', fieldstart) then
      local a, c
      local i  = fieldstart
      repeat
        -- find closing quote
        a, i, c = string.find(s, '"("?)', i+1)
      until c ~= '"'    -- quote not followed by quote?
      if not i then error('unmatched "') end
      local f = string.sub(s, fieldstart+1, i-1)
      fieldname = fieldnames[column]
      if fieldname ~= nil then
	      t[fieldname] = string.gsub(f, '""', '"')
      else
	      table.insert(t, (string.gsub(f, '""', '"')))
      end
      column = column + 1
      fieldstart = string.find(s, ',', i) + 1
    else                -- unquoted; find next comma
      local nexti = string.find(s, ',', fieldstart)
      fieldname = fieldnames[column]
      if fieldname ~= nil then
	      t[fieldname] = string.sub(s, fieldstart, nexti-1)
      else
	      table.insert(t, string.sub(s, fieldstart, nexti-1))
      end
      column = column + 1
      fieldstart = nexti + 1
    end
  until fieldstart > string.len(s)
  return t
end

-- Convert from table to CSV string

--http://lua-users.org/wiki/CsvUtils
--"share code/ideas/links, and collaborate with other users."Ƃ̂Ƃ
--܂B
-- ttcPs̃e[uƂB
-- Convert from table to CSV string
function csv_toCsvLine (tt)
  local s = ""
  for _,p in pairs(tt) do
    s = s .. "," .. csv_escapeCSV(p)
  end
  return string.sub(s, 2)      -- remove first comma
end


--쐬Fނł
function csv_createTable(csvRows)
	local t = {}
	local rowNum = 1

	--擪s̓tB[hB
	local fieldnames = csv_fromLine( csvRows[1] )

	for key,value in pairs(csvRows) do
		t[rowNum] = csv_fromDataline(fieldnames, value)
		rowNum = rowNum + 1
	end

	return t
end


--------------------------------------------------------------------------------
-- Ǎ
--------------------------------------------------------------------------------

--쐬Fނł
function csv_fromText (s)

	local t = {}
	local csvRows = csv_split(s,"\n")

	t = csv_createTable(csvRows)

	return t
end

--쐬Fނł
function csv_fromFile (
	filename,
	... -- QF^Ȃ AIMS  loadFile֐g킸t@CǍށB
)
	local prm = {...}
	local t = {}

	if 1<=#prm and prm[1]==true then
		-- AIMSloadFile֐g킸t@CǍށB
		local rows = {}
		local rowNum = 1
		local f = io.open(filename, "r") --CSVt@CJ܂B

		if( nil~=f )then
			--seLXgt@Cǂݍ݂܂B
			for line in f:lines() do
			    rows[rowNum] = line
				rowNum = rowNum + 1
			end
			--gIt@C܂B
			f:close()

			t = csv_createTable(rows)
		else
			debugOut( "w̃t@C͂܂łB[".. filename .."]" )
		end
	else
		-- AIMSloadFile֐găt@CǍށB
		
		local text = loadFile( filename )
		local lines = csv_split( text, "\n" ) -- s؂

		local rows = {}
		local rowNum = 1

		for rowNo=1, #lines do
			local line = lines[rowNo]
		    rows[rowNum] = line
			rowNum = rowNum + 1
		end

		t = csv_createTable(rows)
	end

	return t
end


--------------------------------------------------------------------------------
-- 
--------------------------------------------------------------------------------

--쐬Fނł
function csv_select(
	t,       -- CSVe[u
	keyFld,  -- L[EtB[h
	expected -- L[l
)

	local hit -- Ys
	-- row ́A1X^[g̍sԍ
	for row,record in ipairs(t) do
		if 3<=row then
			--^ƂĔr܂B
			if record[keyFld]==tostring(expected) then
				hit = record
				break
			end
		end
	end

	return hit
end
